/* Converte arquivo ASC (arquivo de modelos 3D do 3D Studio) para arquivo
de solido (*.S). Cria arquivo de particao (*.PAR) do solido. O arquivo de
particao tem informacoes sobre cores dos poligonos e quais partes do solido
o usuario quer transformar independentemente das demais partes.
Serah criada uma particao que inclui todo solido e uma particao para cada
objeto do arquivo .ASC. */



#include <stdio.h>
#include <stdlib.h>

#include "defs.h"

#include "arquivo.h"



// copia tmp de particao para arq particao
#define COPIA_PAR                                                          \
	      /* pergunta se para cria arquivo de particao */                   \
	      printf ( "Criar arquivo de particao %s (S/N)? ", szNomeArq );     \
         char                                                              \
   	      szResp [ 10 ];                                                 \
         scanf ( "%1s", szResp );                                          \
         /* verifica resposta, se foi Sim cria */                          \
         if ( strcmp ( szResp, "S" ) == 0 || strcmp ( szResp, "s" ) == 0 ) {\
            /* abre arquivos */                                            \
            oArqTP.mAbreArquivo ( "asc2spar", ".tmp", "rt" );              \
            oArqPAR.mAbreArquivo ( szNomeArq, ".par", "wt" );              \
            /* grava numero de particoes, se for 1 objeto estao 1 part */  \
            if ( bUnico )                                                  \
	            oArqPAR.mAtrInt ( 1, FALSE );                               \
            else                                                           \
   	         oArqPAR.mAtrInt ( uNumConv + 1, FALSE );                    \
            oArqPAR.mAtrStr ( "     /* numero de particoes */\n\n" );      \
            /* grava particao geral, de todo solido */                     \
            sprintf ( szStr, "/* Particao 0: %s, poligonos: 0 a %u, particao geral, vertices: */\n0 %u\n\n", \
               szNomeArq, uTotPoligonos - 1, uTotVertices - 1 );           \
            oArqPAR.mAtrStr ( szStr );                                     \
            /* copia arquivo se houveram mais objetos */                   \
            if ( ! bUnico )                                                \
	            while ( oArqTP.mRetLinha ( szStr, 100 ) == TRUE )           \
   	   	      oArqPAR.mAtrLinha ( szStr );                             \
		   }                                                                 \
                                                                           \
         /* apaga arquivo temporario de particao */                        \
         oArqTP.mFechaArquivo ();                                          \
         remove ( "asc2spar.tmp" );



main ( INT nNumArgs, char *szArgs [] )
{
   // verifica se eh para gravar trocado, detecta erro na passagem de params.
   BOOL
   	bTroca = FALSE;
   char
   	szArq [ 200 ];
   // verifica se foi passado algum parametro
   if ( nNumArgs >= 2 )
	   strcpy ( szArq, szArgs [ 1 ] );
   // verifica se foram passados 2 argumentos alem do nome do executavel
   if ( nNumArgs == 3 )
      // verifica se primeiro parametro eh a opcao de troca
		if ( strcmp ( szArgs [ 1 ], "-t" ) == 0 ) {
	   	bTroca = TRUE;
         strcpy ( szArq, szArgs [ 2 ] );
		}
      else
	      // verifica se segundo parametro eh a opcao de troca
			if ( strcmp ( szArgs [ 2 ], "-t" ) == 0 )
		   	bTroca = TRUE;

   // verifica se foram passados parametros corretamente
   if ( nNumArgs != 2 && nNumArgs != 3 || ( nNumArgs == 3 && ! bTroca ) ) {

		printf ( "Conversor de arquivos texto formato 3D Studio (*.ASC) para solido (*.S)." );
   	printf ( "\n\nUse: asc2s [-t] <arquivo_3D_Studio>,              sem a extensao" );
   	printf ( "\n\n - somente objetos seguidos por 'Tri-mesh,' sao convertidos;" );
   	printf ( "\n - o numero de vertices eh definido no campo 'Vertices:';" );
   	printf ( "\n - o numero de poligonos eh metade do valor em 'Faces:'." );
      printf ( "\n\nA opcao -t troca os valores dos componentes Y e Z, tambem inverte a ordem" );
		printf ( "\ndos vertices na secao dos poligonos. Usado para corrigir possivel bug do " );
		printf ( "\n3D Studio na gravacao de arquivos ASC." );
   	printf ( "\n\nPara evitar erros na criacao de arquivos S use nomes de objetos com no" );
		printf ( "\nmaximo 8 caracteres." );
      printf ( "\n\nCria arquivo de particao (*.PAR) do solido.\n" );
      return 0;
   }

   // abre arquivo .ASC
   CArquivo
   	oArqASC ( szArq, ".asc", "rt" );

   // le arquivo ASC convertendo objetos ateh que nao encontre mais objetos
   char
   	szNomeObjeto [ 100 ],  // nome do objeto que estah em conversao
   	szNomeArq [ 100 ],     // nome do arquivo destino (nome do 1o. objeto)
      szToken [ 100 ],       // token lido
      szStr [ 100 ],         // linha do arquivo temporario, ...
      szStrCab [ 100 ];      // cabecalho do arquivo de um objeto
   BOOL
   	bContinua = TRUE,   // se deve continuar conversao ou terminou
      bUnico;
   CArquivo
   	oArqS,              // arquivo de solido
   	oArqPAR,            // arquivo de particao de solido
		oArqT,              // arquivo temporario de solido
      oArqTP;             // arquivo temporario de particao do solido
   UINT16
      // vertices e poligonos de cada objeto tri-mesh
   	uNumVertices,
		uNumPoligonos,
      // total de vertices e poligonos de todos os objetos
   	uTotVertices,
		uTotPoligonos,
     	uNumConv = 0;   // numero de objetos tri-mesh convertidos para o tmp
   do {

      // Procura nome de objeto ateh encontrar um seguido por "Tri-mesh,"
      // "Tri-mesh," marca um objeto com vertices e poligonos.
      BOOL
       	bObjeto;
      do {

        	bObjeto = FALSE;    // nao achou objeto seguido por "Tri-mesh,"

   	   // procura nome de objeto
         // verifica se nao chegou ao fim do arquivo e procura "object:"
    	   if ( ( bContinua = oArqASC.mProcuraStr ( "object:" ) ) == FALSE )
			   break;
         // se encontrou "object:" entao le proximo token (serah nome do objeto)
     	   oArqASC.mRetStr ( szToken );
         // remove aspas do nome
         memcpy ( (void*) szNomeObjeto, (void*) ( szToken + 1 ), strlen ( szToken ) - 2 );
         szNomeObjeto [ strlen ( szToken ) - 2 ] = 0;
         // verifica se o proximo token eh "Tri-mesh," se sim continua
         oArqASC.mRetStr ( szToken );
         if ( strcmp ( szToken, "Tri-mesh," ) == 0 )
         	bObjeto = TRUE;
         else
            // verifica se proximo token nao eh indicacao de numero de pagina
         	if ( strcmp ( szToken, "Page" ) == 0 ) {

            	// se for ignora numero de pagina, tenta ler "Tri-mesh,"
               // le numero de pagina
               oArqASC.mRetStr ( szToken );
               // le proximo tokeen que pode ser "Tri-mesh,"
               oArqASC.mRetStr ( szToken );

               // verifica se eh "Tri-mesh,", se sim sai do loop
		         if ( strcmp ( szToken, "Tri-mesh," ) == 0 )
      		   	bObjeto = TRUE;
            }

      } while ( ! bObjeto );

      // nao encontrou mais objetos: cria arquivos de solido, particao e fim
      if ( ! bObjeto )
         // copia arquivo temporario para solido ou particao
         // se apenas havia um tri-mesh no arquivo tmp
			if ( bUnico ) {

            // copia tmp para arq solido, inclui numero de vertices e pols
            // abre arquivos
            oArqT.mAbreArquivo ( "asc2s", ".tmp", "rt" );
            oArqS.mAbreArquivo ( szNomeArq, ".s", "wt" );
            // le e grava cabecalho
            oArqT.mRetLinha ( szStr, 100 );
            oArqS.mAtrLinha ( szStr );
            // copia linha intermediaria
            oArqT.mRetLinha ( szStr, 100 );
            oArqS.mAtrLinha ( szStr );
	         // escreve numero de vertices
            oArqS.mAtrInt ( uTotVertices, FALSE );
			   // escreve comentario do numero de vertices
      		oArqS.mAtrStr ( "     /* numero de vertices */\n" );
            // escreve numero de poligonos
            oArqS.mAtrInt ( uTotPoligonos, FALSE );
				// escreve comentario do numero de poligonos
      		oArqS.mAtrStr ( "     /* numero de poligonos */\n\n" );
            // copia resto do arquivo
            while ( oArqT.mRetLinha ( szStr, 100 ) == TRUE )
      	      oArqS.mAtrLinha ( szStr );

            // apaga arquivo temporario
            oArqT.mFechaArquivo ();
            remove ( "asc2s.tmp" );

            COPIA_PAR;
	      }
         else { // se haviam varios tri-mesh no tmp

            // abre arquivos
            oArqT.mAbreArquivo ( "asc2s", ".tmp", "rt" );
            oArqS.mAbreArquivo ( szNomeArq, ".s", "wt" );

            // cria cabecalho infomativo de objetos inclusos
				sprintf ( szStr, "/* Convertido por ASC2S. Arquivo original: %s.asc. Total de objetos: %u */\n", szArq, uNumConv );
            oArqS.mAtrStr ( szStr );

            // copia tmp para arq solido, inclui numero de vertices e pols

            // le cabecalho original
            oArqT.mRetLinha ( szStrCab, 100 );

            // copia linha intermediaria
            oArqT.mRetLinha ( szStr, 100 );
            oArqS.mAtrLinha ( szStr );
	         // escreve numero de vertices
            oArqS.mAtrInt ( uTotVertices, FALSE );
			   // escreve comentario do numero de vertices
      		oArqS.mAtrStr ( "     /* numero de vertices */\n" );
            // escreve numero de poligonos
            oArqS.mAtrInt ( uTotPoligonos, FALSE );
				// escreve comentario do numero de poligonos
      		oArqS.mAtrStr ( "     /* numero de poligonos */\n\n" );

            // grava cabecalho original do arquivo temporario e pula 1 linha
            oArqS.mAtrLinha ( szStrCab );
            oArqS.mAtrLinha ( "\n" );

            // copia resto do arquivo
            while ( oArqT.mRetLinha ( szStr, 100 ) == TRUE )
      	      oArqS.mAtrLinha ( szStr );

            // apaga arquivo temporario
            oArqT.mFechaArquivo ();
            remove ( "asc2s.tmp" );

            COPIA_PAR;
         }

      // se nao encontrou mais "object:" entao sai
      if ( ! bContinua )
      	break;

      // verifica se deve criar arquivo temporario
      // se nao existe arquivo temporario criado
      if ( uNumConv == 0 ) {

	      // cria arquivo temporario com definicoes do solido
   	   oArqT.mAbreArquivo ( "asc2s", ".tmp", "wt" );
	      // cria arquivo temporario de particoes
   	   oArqTP.mAbreArquivo ( "asc2spar", ".tmp", "wt" );
         // define nome do arquivo destino
			strcpy ( szNomeArq, szArq );

		   uTotVertices = 0;
			uTotPoligonos = 0;
         bUnico = TRUE;
         uNumConv ++;
		}
      else {   // se for para incluir mais um objeto no arquivo
         uNumConv ++;
         bUnico = FALSE;
      }

      // escreve cabecalho, se for o primeiro sem pular linha no inicio
      if ( uNumConv > 1 )
	      sprintf ( szStr, "\n/* %s */\n\n", szNomeObjeto );
      else
	      sprintf ( szStr, "/* %s */\n\n", szNomeObjeto );
      oArqT.mAtrStr ( szStr );

		// inicia secao de vertices e escreve comentario sobre inicio deles
      oArqT.mAtrStr ( "V: /* vertices (x, y, z) */\n" );

      // define numero de vertices do objeto no arquivo ASC
    	if ( ( bContinua = oArqASC.mProcuraStr ( "Vertices:" ) ) == FALSE )
			break;
      // se encontrou "Vertices:" entao le numero de vertices
     	oArqASC.mRetInt ( (INT16&) uNumVertices );

      // define numero de poligonos do objeto no arquivo ASC
    	if ( ( bContinua = oArqASC.mProcuraStr ( "Faces:" ) ) == FALSE )
			break;
      // se encontrou "Faces:" entao le numero de faces
     	oArqASC.mRetInt ( (INT16&) uNumPoligonos );
      // cada poligono define 2 faces logo poligonos = faces / 2
      uNumPoligonos /= 2;

      // le vertices e grava valores no arquivo temporario
      for ( UINT16 ucV = 0; ucV < uNumVertices; ucV ++ ) {

      	// procura inicio das componentes (componente x)
         oArqASC.mProcuraStr ( "X:" );

         // le componentes e grava
         INT16
            nComponenteX,
            nComponenteY,
            nComponenteZ;
         // le x
         oArqASC.mRetInt ( nComponenteX );
         // le y
         oArqASC.mRetStr ( szToken );
         oArqASC.mRetInt ( nComponenteY );
         // le z
         oArqASC.mRetStr ( szToken );
         oArqASC.mRetInt ( nComponenteZ );

         // grava x
         oArqT.mAtrStr ( "   " );
         oArqT.mAtrInt ( nComponenteX );
         oArqT.mAtrStr ( " " );
         // verifica se nao eh para gravar trocado, se sim troca Y e Z
         if ( bTroca ) {
         	INT16
            	nTemp = nComponenteY;
            nComponenteY = nComponenteZ;
            nComponenteZ = nTemp;
         }
         // grava y
         oArqT.mAtrInt ( nComponenteY );
         oArqT.mAtrStr ( " " );
         // grava z
         oArqT.mAtrInt ( nComponenteZ );

         // grava comentario de indice do vertice
			sprintf ( szStr, "       /* %u */\n", ucV + uTotVertices );
         oArqT.mAtrStr ( szStr );
		}

		// inicia secao de poligonos e escreve comentario sobre inicio deles
      oArqT.mAtrStr ( "\nP: /* poligonos (v1, v2, v3, v4) - vertices em ordem anti-horaria */\n" );

      // acha inicio da lista de faces
      oArqASC.mProcuraStr ( "list:" );

      // le poligonos e grava valores no arquivo temporario
      for ( UINT16 ucP = 0; ucP < uNumPoligonos; ucP ++ ) {

      	// posiciona leitura proximo (logo antes) ao primeiro vertice
         oArqASC.mProcuraStr ( "Face" );
         oArqASC.mRetStr ( szToken );

         // le indice do primeiro vertice
         oArqASC.mRetStr ( szToken );
         // remove caracteres extra
         strcpy ( szStr, szToken + 2 );
         // converte string para numero e grava
         UINT16
         	uV1 = (UINT16) atoi ( szStr );

         // le indice do segundo vertice
         oArqASC.mRetStr ( szToken );
         // remove caracteres extra
         strcpy ( szStr, szToken + 2 );
         // converte string para numero e grava
         UINT16
         	uV2 = (UINT16) atoi ( szStr );

         // le indice do terceiro vertice
         oArqASC.mRetStr ( szToken );
         // remove caracteres extra
         strcpy ( szStr, szToken + 2 );
         // converte string para numero e grava
         UINT16
         	uV3 = (UINT16) atoi ( szStr );

         // procura e le indice do quarto vertice
			// (o 3D Studio repete vertices por gravar triangulos)
         UINT16
         	uV4;
         oArqASC.mProcuraStr ( "Face" );
         oArqASC.mRetStr ( szToken );
         // faz procura pelo vertice de indice diferente dos jah definidos
         for ( INT16 ncV = 0; ncV < 3; ncV ++ ) {

            // le candidato a quarto vertice
            oArqASC.mRetStr ( szToken );
            // remove caracteres extra
            strcpy ( szStr, szToken + 2 );
            // converte string para numero
            uV4 = (UINT16) atoi ( szStr );
            // verifica se nao existe, se nao existe termina procura, achou
            if ( uV4 != uV1 && uV4 != uV2 && uV4 != uV3 )
            	break;
         }

         // grava vertices e espacos entre vertices
         oArqT.mAtrStr ( "   " );
         // verifica se eh para gravar trocado, se sim grava trocado
         if ( bTroca ) {
            oArqT.mAtrInt ( (INT16) uV4 + uTotVertices, FALSE );
	         oArqT.mAtrStr ( " " );
            oArqT.mAtrInt ( (INT16) uV3 + uTotVertices, FALSE );
	         oArqT.mAtrStr ( " " );
            oArqT.mAtrInt ( (INT16) uV2 + uTotVertices, FALSE );
	         oArqT.mAtrStr ( " " );
            oArqT.mAtrInt ( (INT16) uV1 + uTotVertices, FALSE );
         }
         else { // nao grava trocado
            oArqT.mAtrInt ( (INT16) uV1 + uTotVertices, FALSE );
	         oArqT.mAtrStr ( " " );
            oArqT.mAtrInt ( (INT16) uV2 + uTotVertices, FALSE );
	         oArqT.mAtrStr ( " " );
            oArqT.mAtrInt ( (INT16) uV3 + uTotVertices, FALSE );
	         oArqT.mAtrStr ( " " );
            oArqT.mAtrInt ( (INT16) uV4 + uTotVertices, FALSE );
         }

         // grava comentario de indice do poligono
			sprintf ( szStr, "       /* %u */\n", ucP + uTotPoligonos );
         oArqT.mAtrStr ( szStr );
      }

      // grava dados no arquivo de particao
      sprintf ( szStr, "/* Particao %u: %s, poligonos: %u a %u */\n%u  %u\n\n",
        uNumConv, szNomeObjeto,
 		  uTotPoligonos, uTotPoligonos + uNumPoligonos - 1,
		  uTotVertices, uTotVertices + uNumVertices - 1 );
      oArqTP.mAtrStr ( szStr );

      // inclui no total de vertices e poligonos
      uTotVertices += uNumVertices;
      uTotPoligonos += uNumPoligonos;

	} while ( bContinua );
}
