/* Funcoes de acesso a arquivos de dados 2D: bitmaps.

Deriva de CArquivo.

Formato de arquivos suportados:
PCX Z-Soft 5.0                        */



#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "defs.h"

#include "arquivo.h"

#include "imagem.h"

#include "arq2d.h"



/* construtor - nao carrega arquivo
**********************************************************/
CArquivo2D::CArquivo2D ()
{
   m_pfArq = NULL;
   m_szNomeArq [ 0 ] = 0;
}



/* construtor - carrega arquivo
**********************************************************/
CArquivo2D::CArquivo2D ( char* szArq, CImagem& oI, BOOL bPal )
{
   mRetObjeto ( szArq, oI, bPal );
}



/* Carrega arquivo PCX
**********************************************************/
void CArquivo2D::mRetObjeto ( char* szArq, CImagem& oI, BOOL bPal )
{
   // abre arquivo de dados
   mAbreArquivo ( szArq, ".pcx", "rb" );

   // le cabecalho
   tagCabecalhoPCX
      stCab;
   mRetMem ( sizeof ( tagCabecalhoPCX ), (void*) &stCab );
   // define tamanho da imagem
   UINT
      uTam = ( stCab.uXMax - stCab.uXMin + 1 ) * ( stCab.uYMax - stCab.uYMin + 1 );

   // aloca memoria
   // verifica se deve alocar memoria para palette, se sim aloca
   if ( bPal )
      oI.mAlocaMemoria ( stCab.uXMax - stCab.uXMin + 1, stCab.uYMax - stCab.uYMin + 1, 768 );
   else
      // nao deve ser alocada memoria para palette
      oI.mAlocaMemoria ( stCab.uXMax - stCab.uXMin + 1, stCab.uYMax - stCab.uYMin + 1, 0 );

   // verifica se deve carregar palette
   if ( bPal ) {

      // le palette (768 bytes de extensao: 3 bytes por cor (RGB) * 256 cores)
      // le ultimos 768 bytes (palette estah no fim do arquivo)
      mPosFim ();
      mPosAtual ( -768 );
      mRetMem ( 768, (void*) oI.m_ayPal );

      // Converte palette de 8 bits por componente para 6 bits (forma usada no
      // modo grafico default).
      // divide cada componente de RGB da palette por 4 (>> 2)
      for ( UINT16 ucP = 0; ucP < 768; ucP ++ )
         oI.m_ayPal [ ucP ] = oI.m_ayPal [ ucP ] >> 2;
   }

   // le imagem
   // posiciona apohs primeiros 128 bytes
   mPosIni ();
   mPosAtual ( 128 );
   // aponta para o fim da imagem
   BYTE
      *pyAtual = oI.m_ayImg,
      *pyFim = oI.m_ayImg + uTam;
   // enquanto nao chegar ao fim vai alterando memoria da imagem
   while ( pyAtual < pyFim ) {

      // le numero de ocorrencias da proxima cor ou cor
      BYTE
         yVal;
      mRetMem ( 1, (void*) &yVal );

      // se valor lido for menor que 192 entao eh uma cor
      if ( yVal < 192 ) {

         *pyAtual = yVal;
         pyAtual ++;
      }
      else { // senao eh o numero de correncias da proxima cor

         // calcula numero de ocorrencias, apenas primeiros 6 bits validos
         yVal &= 0x3F;
         // le cor
         BYTE
            yCor;
         mRetMem ( 1, (void*) &yCor );
         // altera memoria da imagem
         memset ( pyAtual, yCor, yVal );
         // avanca ponteiro da imagem
         pyAtual += yVal;
      }
   }

   // fecha arquivo
   mFechaArquivo ();
}
