/* Declaracoes de controle.cc */



class CControle {

public:

   CControle ();

private:

   // tabelas que indicam que quadrados do tabuleiro possuem quais pecas
   // se posicao possuir 0 indica que estah vazio, senao possuirah o numero
   // da peca que ocupa a posicao
   BYTE m_ayTabAtual [8][8];  // tabuleiro logo apohs a jogada atual [Y][X]
   BYTE m_ayTabAnter [8][8];  // tabuleiro na jogada anterior

   void mRemove ( INT16 nLin, INT16 nCol );
   BOOL mMove ( UINT16 uPeca, INT16 nDLin, INT16 nDCol );
   BOOL mMonoMove ( BYTE yComando, INT16 nDir, UINT16& uPeca );
   void mRemove ( UINT16 uPeca );
   BOOL mColoca ( UINT16 uPeca, INT16 nLin, INT16 nCol );
   INT16 mRetPeca ( INT16 nLin, INT16 nCol );
   void mDamifica ( UINT16 uPeca );
   BOOL mRetEhDama ( UINT16 uPeca );
   BYTE mRetPosTime ( INT16 nLin, INT16 nCol );
   BOOL mRetDeveAtacar ( UINT16 uPeca, INT16 nDir, BYTE* ayDirecoes );
   BOOL mAutoMoveObrig ( BYTE yComando, INT16 nTime, UINT16& uPSel );

   // funcoes do minimax
   void  mMMarcaVd ( BYTE yComando, UINT16 uPeca, BYTE yCor );
   INT16 mMRetPosTipoPeca ( INT16 nLin, INT16 nCol );
   INT16 mMRetContaVivas ( INT16 nTime );
   BOOL  mMAutoMove ( BYTE yComando, INT16 nTime, UINT16 uPSel );
   INT16 mMAvalia ();
   void  mMSalvaAtual ( BYTE* ayTab );
   void  mMRestauraAtual ( BYTE* ayTab );
   INT   mMinimax ( INT16 nCmd, UINT16 uPeca, INT16 nMaxProf, INT16 nNivel );

public:

   // dados sobre o ultimo movimento do computador
   BYTE m_yUltComando;       // comando executado, direcao
   BYTE m_yUltPeca;          // peca movida
   BYTE m_yUltProf;          // profundidade do minimax

   BOOL mRetViva ( UINT16 uPeca );
   UINT16 mRetValorAtualPeca ( UINT16 uPeca );
   UINT16 mRetValorOrigPeca ( UINT16 uPeca );
   BOOL mRetPosAnter ( UINT16 uPeca, INT16& nLin, INT16& nCol );
   BOOL mRetPos ( UINT16 uPeca, INT16& nLin, INT16& nCol );
   void mAtrAtual ( INT16 nValor, INT16 nLin, INT16 nCol );
   void mMostra ();
   void mAtualiza ();

   BOOL mJogadaComputador ( INT16 nMinNiveis );
   BOOL mJogadaUsuario ( BYTE yComando, UINT16 &uPeca );
};
