/* Altera particoes do universo

Derivado de CControleSolido */



#include <stdio.h>

#include "defs.h"

#include "solido.h"

#include "arquivo.h"

#include "arq3d.h"

#include "universo.h"

#include "sr.h"

#include "transf.h"

#include "contrsol.h"

#include "contruni.h"



/* construtor - inicia sem objeto definido
**********************************************************/
CControleUniverso::CControleUniverso ()
{
   m_poU = NULL;
}



/* construtor - inicia jah definindo universo a ser manipulado
**********************************************************/
//CControleUniverso::CControleUniverso ( CUniverso& oU )



/* Define universo a ser manipulado
**********************************************************/
void CControleUniverso::mAtrObjeto ( CUniverso& oU )
{
   m_poU = &oU;
   CControleSolido::mAtrObjeto ( (CSolido&) oU );
}



/* Define o ponto medio de uma particao
**********************************************************/
void CControleUniverso::mRetMeio ( UINT16 uParte, INT& nXM, INT& nYM, INT& nZM )
{
   nXM = nYM = nZM = 0;

   // define primeiro e ultimo vertice da faixa de vertices a ser calculada
   UINT16
      uIni = * ( m_poU->m_pauPaIni + uParte ),
      uFim = * ( m_poU->m_pauPaFim + uParte );
   // soma valores
   for ( UINT16 ucV = uIni; ucV <= uFim; ucV ++ ) {
      nXM += * ( m_poU->m_panX + ucV );
      nYM += * ( m_poU->m_panY + ucV );
      nZM += * ( m_poU->m_panZ + ucV );
   }

   // faz medias
   nXM = nXM / ( uFim - uIni + 1 );
   nYM = nYM / ( uFim - uIni + 1 );
   nZM = nZM / ( uFim - uIni + 1 );
}



/* Faz escala transladando objeto conforme ponto medio mais
 23 unidades. (ESPECIALMENTE FEITO PARA ESCALA DAS PECAS)
**********************************************************/
void CControleUniverso::mEscalaMed ( float fEX, float fEY, float fEZ, CUniverso& oU, UINT16 uParte )
{
   // define ponto medio da particao
   // valores medios
   INT
      nXM,
      nYM,
      nZM;
   mRetMeio ( uParte, nXM, nYM, nZM );

   // translada particao do solido para origem (conforme ponto medio)
   m_oTransf.mTranslada ( - nXM, - nYM - 23, nZM, *m_poU, uParte );

   // faz escala em Y (estica)
   m_oTransf.mEscala ( fEX, fEY, fEZ, *m_poU, uParte );

   // translada particao do solido devolta a posicao original
   m_oTransf.mTranslada ( nXM, nYM + 23, - nZM, *m_poU, uParte );
}



/* Define a particao que compoe uma determinada peca.
uPeca deve estar entre 1 e 24.
**********************************************************/
UINT16 CControleUniverso::mRetParticao ( UINT16 uPeca )
{
   return INIPARSPECAS + uPeca - 1;
}



/* Define qual o primeiro poligono de uma peca na tabela de
poligonos do solido. uPeca deve estar entre 1 e 24.
**********************************************************/
UINT16 CControleUniverso::mRetPol1 ( UINT16 uPeca )
{
   return INIPOLSPECAS + ( uPeca - 1 ) * POLSPECA;
}
