/* Definicoes basicas */



// ESPECIFICAS DO JOGO

// posicao vazia na tabela de posicoes
#define VAZIO 255

// numero de pecas de cada time
#define NPECAS 12

// cor time usuario
#define CORUSUARIO 128

// cor time computador
#define CORCOMPUTADOR 96

// cor da peca selecionada
#define CORSEL 160

// poligonos por peca
#define POLSPECA 10

// inicio dos poligonos de pecas
#define INIPOLSPECAS 384

// inicio das particoes de pecas
#define INIPARSPECAS 65

// unidades por quadrado
#define UNPOS 100

// se uma peca eh dama o seu valor eh somado a esse, identifica uma dama
#define DAMA 64

// identificacao geral do time do usuario
#define TIMEU 12

// identificacao geral do time do computador
#define TIMEC 0

// possiveis comandos para mover pecas
#define CMD_HOME 0
#define CMD_PG_UP 1
#define CMD_END 2
#define CMD_PG_DN 3

// tamanho de um tabuleiro em bytes
#define TAMTAB 64

// arquivos de dados:
#define STR_ARQ_TABULEIRO "dados/default"
#define STR_ARQ_DEFMET "dados/defmet"
#define STR_ARQ_INIC "dados/inic"
#define STR_ARQ_INFO "dados/infoi"
#define STR_ARQ_OBSINI "dados/obsini"

// maximo de frames por segundo que eh permitido
#define MAXFPS 30



// TIPOS

// inteiro sem sinal de 8 bits
#define BYTE unsigned char

// inteiros de 32 bits
#define UINT unsigned int
#define INT  int

// inteiros de 16 bits
#define UINT16 unsigned short int
#define INT16  short int

// booleano
#define BOOL unsigned char
#define TRUE 1
#define FALSE 0



// CODIGOS DAS TECLAS

// Posicao a partir da qual se encontram as teclas especiais, usado para
// fazer referencia a teclas especiais. Ex: 72 + ESPECIAL -> seta para cima.
#define ESPECIAL 128

// Teclas, sem comentario - tecla convensional, detectar: codigo_da_tecla;
//         especial - tecla especial, detectar: codigo_da_tecla;
//         especial ou nao - codigo refere-se a 2 teclas, uma especial e
//         outra convensional, detectar: codigo_da_tecla + ESPECIAL
//         ou codigo_da_tecla (comum).
// comum
#define T_ESC     1
#define T_1       2
#define T_2       3
#define T_3       4
#define T_4       5
#define T_5       6
#define T_6       7
#define T_7       8
#define T_8       9
#define T_9      10
#define T_0      11
// especial ou nao
#define T_SOB     72
#define T_DIR     77
#define T_DES     80
#define T_ESQ     75
#define T_HOME    71
#define T_PG_UP   73
#define T_PG_DN   81
#define T_END     79
#define T_ENTER   28
#define T_TAB     15
#define T_ESPACO  57
#define T_A       30
#define T_B       48
#define T_C       46
#define T_D       32
#define T_E       18
#define T_F       33
#define T_G       34
#define T_H       35
#define T_I       23
#define T_J       36
#define T_K       37
#define T_L       38
#define T_M       50
#define T_N       49
#define T_O       24
#define T_P       25
#define T_Q       16
#define T_R       19
#define T_S       31
#define T_T       20
#define T_U       22
#define T_V       47
#define T_W       17
#define T_X       45
#define T_Y       21
#define T_Z       44
#define T_ALT_E   56
#define T_CTRL_E  29
#define T_SHIFT_E 42
#define T_F1      59
#define T_F2      60
#define T_F3      61
#define T_F4      62
#define T_F5      63
// especial
#define T_ALT_D   56 + ESPECIAL
#define T_CTRL_D  29 + ESPECIAL
#define T_SHIFT_D 42




// MENSAGENS

/* PORTUGUES
#define MSG_SEMMEMORIA "\nImpossivel alocar memoria, memoria esgotada."
#define MSG_IMPOSSIVELEXECUTAR "\nImpossivel executar aplicativo."
#define MSG_ERROABRIRARQUIVO "\nImpossivel abrir arquivo %s."
#define MSG_ERROLETKARQUIVO "\nErro ao ler token do arquivo %s."
#define MSG_ERROLEITURASTR "\nErro ao ler token.\n"
#define MSG_ERROCOMENTARIOABERTO " Erro causado possivemente por \
comentario aberto sem ser fechado. Havia(m) %u comentario(s) aberto(s) quando \
ocorreu o erro."
#define MSG_AVISOFIMCOMENTO "Encontrado fim de comentario sem o seu respectivo \
inicio, ignorado."
#define MSG_ERROFIMARQUIVO " Encontrado o fim do arquivo inesperadamente."
#define MSG_TEMPO "Frames per second: %f\nPlay time: %u min.\n"
*/

#define MSG_SEMMEMORIA "\nNo memory."
#define MSG_IMPOSSIVELEXECUTAR "\nImpossible execute aplication."
#define MSG_ERROABRIRARQUIVO "\nImpossible open file %s."
#define MSG_ERROLETKARQUIVO "\nError reading token on file %s."
#define MSG_ERROLEITURASTR "\nError reading token.\n"
#define MSG_ERROCOMENTARIOABERTO " Still open %u remarks. Error probably caused by one or more open remarks without close remarks."
#define MSG_AVISOFIMCOMENTO " End remark found without open remark, ignoring."
#define MSG_ERROFIMARQUIVO " Unexpected end of file."
#define MSG_TEMPO "Frames per second: %f\nPlay time: %u min.\n"
#define MSG_TITULO \
"\nCheckers 3D version 1.1, Copyright (C) 1998 Leandro Bernsmuller \
\nCheckers 3D comes with ABSOLUTELY NO WARRANTY. \
\nThis is free software, and you are welcome to redistribute it \
\nunder certain conditions; read doc/LICENSE for details. \
\n\ne-mail: lebe@geocities.com \
\nsite:   http://www.geocities.com/SiliconValley/Bay/1704\n\n"



// VIDEO, VIEWPORT, DIMENSOES DE ESTRUTURAS DE DADOS, HARDWARE

// modos de video
// MCGA: 320x200x256 (modo grafico default)
#define MCGA  0x0013
// texto comum
#define TEXTO 0x0003

// resolucao de video no modo grafico
#define RESX 320
#define RESY 200

// meio da tela
// ( RESX >> 1 )
#define RESX2 160
// ( RESY >> 1 )
#define RESY2 100

// valores maximos e minimos para coordenadas no video (modo grafico default)
#define MINX 0
#define MINY 0
// MAXX ( RESX - 1 )
#define MAXX 319
// MAXY ( RESY - 1 )
#define MAXY 199

// tamanho a memoria virtual de video, ( RESX * RESY )
#define TAMVR 64000
// um quarto do tamanho da memoria virtual de video, ( RESX * RESY ) >> 2
#define TAMVR4 16000

// numero de entradas da pallete para tons de uma cor
#define NUMCOR 32
// valor basico do RGB das cores na pallete (+- ajusta luz ambiente)
#define ILUMAMB 18



// MATEMATICA, TRANSFORMACOES, COORDENADAS VIRTUAIS

// numero PI
#define Pi 3.14159265359

// angulos, NANGS,...
// numero de unidades para completar uma volta (em graus seria 360)
#define NANGS 256
// numero de unidades para completar meia volta (graus seria 180), NANGS / 2
#define NANGS2 128
// numero de unidades para completar 1/4 de volta (em graus: 90), NANGS >> 2
#define NANGS4 64
// numero maximo que as unidades para completar uma volta, NANGS - 1
#define MAXANGS 255

// limites para operacoes em Z
// valor maximo e minimo para Z
#define MAXZ 10000
#define MINZ -10000
// valor de recorte para Z proximo e longe da camera, ou:
// -(distancia_CP - 2) ou outro valor
#define RECMINZ -175
// deve ser menor ou igual a MAXZ
#define RECMAXZ 7000
// limite de visibilidade (de acordo com Z), para "deep-cuering"
#define FIMIZ 200
// distancia do centro de projecao ateh o plano de projecao
#define DISTCP 300
// calcula o modulo (comprimento) de um vetor
#define MODULO(X, Y, Z) ( (float) sqrt ( (float) ( ( X ) * ( X ) + ( Y ) * ( Y ) + ( Z ) * ( Z ) ) ) )



// PREDECLARACOES DE CLASSES

class CArquivo;
class CArquivo3D;
class CArquivo2D;
class CControleSolido;
class CControleUniverso;
class CSolido;
class CUniverso;
class CImagem;
