/* Armazena uma imagem 2D (bitmap) e sua palette. */



#include <stdio.h>    // acesso a NULL

#include "defs.h"

#include "arquivo.h"

#include "arq2d.h"

#include "imagem.h"



/* contrutor - inicia sem imagem
**********************************************************/
CImagem::CImagem ()
{
   m_ayImg = m_ayPal = NULL;
   m_uDimX = m_uDimY = m_uTamPal = 0;
}



/* contrutor - carrega imagem de arquivo
bPal: TRUE - carrega palette; FALSE - nao carrega palette
**********************************************************/
CImagem::CImagem ( char* szArq, BOOL bPal )
{
   CArquivo2D
      oArq ( szArq, *this, bPal );
}



/* destrutor - Desaloca memoria, se for o caso
**********************************************************/
CImagem::~CImagem ()
{
   // verifica se foi alocado
   if ( m_ayImg != NULL )
      delete m_ayImg;
   // verifica se foi alocado
   if ( m_ayPal != NULL )
      delete m_ayPal;
}



/* Aloca memoria, se nao conseguir sai
**********************************************************/
void CImagem::mAlocaMemoria ( UINT16 uDimX, UINT16 uDimY, UINT uTamPal )
{
   m_uDimX = uDimX;
   m_uDimY = uDimY;
   m_uTamPal = uTamPal;
   m_ayImg = m_ayPal = NULL;

   // tenta locar memoria para imagem, se for o caso
   if ( m_uDimX != 0 && m_uDimY != 0 )
      if ( ( m_ayImg = new BYTE [ m_uDimX * m_uDimY ] ) == NULL ) {
         printf ( MSG_SEMMEMORIA );
         exit ( 1 );
      }

   // tenta locar memoria para palette, se for o caso
   if ( m_uTamPal != 0 )
      if ( ( m_ayPal = new BYTE [ m_uTamPal ] ) == NULL ) {
         printf ( MSG_SEMMEMORIA );
         exit ( 1 );
      }
}
