/* Declaracoes de solido.cc */



class CSolido {

public:

   CSolido ();
   CSolido ( CSolido &oS );
   CSolido ( char* szArq );
   CSolido ( char* szArq, CArquivo3D& oArq );
   ~CSolido ();

private:

   UINT16 m_uMaxVertices;    // numero maximo de vertices
   UINT16 m_uMaxPoligonos;   // numero maximo de poligonos que formam solido

public:

   UINT16 m_uNumVertices;    // numero de vertices definidos atualmente
   UINT16 m_uNumPoligonos;   // numero de poligonos definidos atualmente
   // tabelas de vertices (cada vertice eh dividido em sua componente x,y,z)
   INT16* m_panX;            // componentes x dos vertices do solido
   INT16* m_panY;            // componentes y dos vertices do solido
   INT16* m_panZ;            // componentes z dos vertices do solido
   // tabelas de poligonos (formados com ateh 4 vertices)
   UINT16* m_pauV1;          // conjunto de vertices 1 que formam poligonos
   UINT16* m_pauV2;          // conjunto de vertices 2 que formam poligonos
   UINT16* m_pauV3;          // conjunto de vertices 3 que formam poligonos
   UINT16* m_pauV4;          // conjunto de vertices 4 que formam poligonos
   // tabelas com vertices nao sobrepostos (usar para calcular vetor normal)
   UINT16* m_pauVNC1;        // primeiro vertice nao sobreposto (origem vets)
   UINT16* m_pauVNC2;        // segundo vertice nao sobreposto
   UINT16* m_pauVNC3;        // terceiro vertice nao sobreposto
   // tabelas para ordenacao dos poligonos (proximidade com origem)
   INT16*  m_panD;   // uso temporario: possui distancia
   UINT16* m_pauP;   // possui os indices dos poligonos (ordenados)
   // tabela de cores (associa uma cor a um poligono)
   BYTE* m_payCor;   // cor do poligono correspondente a mesma posicao

   void mAlocaMemoria ( UINT16 uMaxVert, UINT16 uMaxPol );
   void mAtrVertice ( INT16 nX, INT16 nY, INT16 nZ );
   void mAtrPoligono ( UINT16 uV1, UINT16 uV2, UINT16 uV3, UINT16 uV4, BYTE yCor );
   void mCriaCompativel ( CSolido &oS );
   UINT16 mRetMaxVertices ();
   UINT16 mRetMaxPoligonos ();
};
