/* Descreve um solido dividido em partes que podem ser operadas
individualmente. Possui infomacao sobre quais vertices pertencem a quais
conjuntos de vertices (particoes). Cada vertice pode pertencer a varias
particoes. Cada particao pode ser operada (rotacionada, transladada,...) em
separado das demais.
Essa classe eh derivada de CSolido, acrescenta tabela de particoes. */



#include <stdio.h>       // acesso a NULL
#include <math.h>

#include "defs.h"

#include "arquivo.h"

#include "arq3d.h"

#include "solido.h"

#include "universo.h"



/* construtor
**********************************************************/
CUniverso::CUniverso ()
{
   m_uMaxPartes = 0;
   m_uNumPartes = 0;
   m_pauPaIni = m_pauPaFim = NULL;
}



/* construtor - carrega arquivo de objeto arquivo, ver .h
**********************************************************/
// CUniverso::CUniverso ( char* szArq )



/* construtor - carrega arquivo de um objeto arquivo externo, ver .h
**********************************************************/
// CUniverso::CUniverso ( char* szArq, CArquivo3D& oArq )



/* destrutor - desaloca memoria
**********************************************************/
CUniverso::~CUniverso ()
{
   if ( m_pauPaIni != NULL )
      delete m_pauPaIni;
   if ( m_pauPaFim != NULL )
      delete m_pauPaFim;
}



/* Aloca memoria. Deve ser chamado antes de iniciar atribuicao de dados.
**********************************************************/
void CUniverso::mAlocaMemoria ( UINT16 uMaxPa )
{
   // define dimensoes
   m_uMaxPartes = uMaxPa;
   m_uNumPartes = 0;
   m_pauPaIni = m_pauPaFim = NULL;

   // tenta alocar memoria para tabelas de particoes
   if ( ( m_pauPaIni = new UINT16 [ m_uMaxPartes ] ) == NULL ) {
      printf ( MSG_SEMMEMORIA );
      exit ( 1 );
   }
   if ( ( m_pauPaFim = new UINT16 [ m_uMaxPartes ] ) == NULL ) {
      printf ( MSG_SEMMEMORIA );
      exit ( 1 );
   }
}



/* Inclui uma particao nas matrizes de particoes
**********************************************************/
void CUniverso::mAtrParte ( UINT16 uIni, UINT16 uFim )
{
   * ( m_pauPaIni + m_uNumPartes ) = uIni;
   * ( m_pauPaFim + m_uNumPartes ) = uFim;

   // verifica esgotamento do universo para solidos
   if ( m_uNumPartes < m_uMaxPartes )
      m_uNumPartes ++;
}



/* return maximo de particoes que o universo pode ter
**********************************************************/
UINT16 CUniverso::mRetMaxPartes ()
{
   return m_uMaxPartes;
}
